package org.onosproject.nemo.model.object.property.definitions;

import static org.junit.Assert.assertEquals;

import org.junit.Test;
import org.onosproject.nemo.model.common.PropertyName;

import com.google.common.testing.EqualsTester;

/**
 * Unit tests for {@link PropertyDefinitionKey}.
 */
public class PropertyDefinitionKeyTest {

    private static final String NAME = "SomeName";
    private static final String OTHER = "OtherName";
    private static final String NAME_ERROR_MSG = "name not set";

    private PropertyDefinitionKey key;
    private PropertyDefinitionKey copy;
    private PropertyDefinitionKey diff;

    @Test
    public void fromActionName() {
        key = new PropertyDefinitionKey(new PropertyName(NAME));
        assertEquals(NAME_ERROR_MSG, NAME, key.getPropertyName().getValue());
    }

    @Test
    public void copyConstructor() {
        key = new PropertyDefinitionKey(new PropertyName(NAME));
        copy = new PropertyDefinitionKey(key);
        new EqualsTester()
                .addEqualityGroup(key, copy)
                .testEquals();
    }

    @Test
    public void equality() {
        key = new PropertyDefinitionKey(new PropertyName(NAME));
        copy = new PropertyDefinitionKey(new PropertyName(NAME));
        diff = new PropertyDefinitionKey(new PropertyName(OTHER));
        new EqualsTester()
                .addEqualityGroup(key, copy)
                .addEqualityGroup(diff)
                .testEquals();
    }
}