package org.onosproject.nemo.model.object.property.instance.property.values;

import static org.junit.Assert.assertEquals;

import org.junit.Test;

import com.google.common.testing.EqualsTester;

/**
 * Unit tests for {@link StringValueKey}.
 */
public class StringValueKeyTest {

    private static final String VALUE = "SomeValue";
    private static final String OTHER_VALUE = "OtherValue";
    private static final String VALUE_ERROR_MSG = "value not set";
    private static final long ORDER = 1;
    private static final long OTHER_ORDER = 2;
    private static final String ORDER_ERROR_MSG = "order not set";

    private StringValueKey source;
    private StringValueKey copy;
    private StringValueKey diff;

    @Test
    public void fromStringValueKey() {
        source = new StringValueKey(ORDER,VALUE);
        assertEquals(VALUE_ERROR_MSG, VALUE, source.getValue());
        assertEquals(ORDER_ERROR_MSG, ORDER, source.getOrder());
    }

    @Test
    public void copyConstructor() {
        source = new StringValueKey(ORDER,VALUE);
        copy = new StringValueKey(source);
        new EqualsTester()
                .addEqualityGroup(source, copy)
                .testEquals();
    }

    @Test
    public void equality() {
        source = new StringValueKey(ORDER,VALUE);
        copy = new StringValueKey(ORDER,VALUE);
        diff = new StringValueKey(OTHER_ORDER,OTHER_VALUE);
        new EqualsTester()
                .addEqualityGroup(source, copy)
                .addEqualityGroup(diff)
                .testEquals();
    }
}